#ifndef DATASTRUCTURE_H
#define DATASTRUCTURE_H

#include <stdio.h>
#include <string.h>
#include <malloc.h>

typedef enum {wordType, numberType} dataType;

typedef struct Value{
	dataType type;
	union {
		int ivalue;
		char *svalue; // it's a pointer, needs to be deleted
	} u;
} Value;

//*********************************************

typedef struct elementNode *elementNodePtr;
typedef struct statementNode *statementNodePtr;
typedef struct enumerationNode *enumerationNodePtr;

//*********************************************
typedef enum {value, statement} elementType;

typedef struct elementNode{
	elementType type;
	union {
		struct Value _value;
		statementNodePtr stmt;
	} u;
} elementNode;

elementNodePtr createValueElement(struct Value _value);
elementNodePtr createStatementElement(statementNodePtr stmt);

//*********************************************
typedef struct statementNode{
	enumerationNodePtr ePtr;
} statementNode;

statementNodePtr createStatement(enumerationNodePtr ePtr);

//*********************************************

typedef struct enumerationNode{
	elementNodePtr element;
	enumerationNodePtr next; // linked list

} enumerationNode;

enumerationNodePtr createEnumerationNode(enumerationNodePtr next, elementNodePtr element);

//*********************************************
// Methods for traversing and processing the tree

char* processStatement(statementNodePtr root);
char* processEnum(enumerationNodePtr ePtr);
char* processEnumElement(elementNodePtr element);

#endif
