%{
#include <stdio.h>
#include <stdlib.h>
#include "datastructure.h"

#include "y.tab.h"

int current_line_number = 1;

int current_pos = 1;

void newline() {
	current_line_number++;
	current_pos = 1;
}

void increase_pos(){
	current_pos++;
}

void increase_pos_by(int offset){
	current_pos += offset;
}


%}
%%
\{                      increase_pos(); return OBRACE;
\}                      increase_pos(); return EBRACE;
;                       increase_pos(); return SEMICOLON;

[a-zA-Z]+		{
			yylval.GenericValue.u.svalue = strdup(yytext); 
			yylval.GenericValue.type=wordType; 
			increase_pos_by(strlen(yytext)); 
			return WORD;
			}

[0-9]+			{
			yylval.GenericValue.u.ivalue = atoi(yytext); 
			yylval.GenericValue.type=numberType; 
			increase_pos_by(strlen(yytext)); 
			return NUMBER;
			}

\n                      {
			newline();
			/* ignore end of line */;
			}

[ \t]+                  {
			increase_pos_by(strlen(yytext));
			/* ignore whitespace */;
			}
%%
